// Addin.cpp : Implementation of CAddin
#include "stdafx.h"
#include "SpamWatchAddin.h"
#include "Addin.h"
#include <process.h>

#include <boost/regex.hpp>
#include <string>
#include <vector>

#include "SpamWatchClient.h"
#include <atlconv.h>
#include <tchar.h>

using namespace boost;

// XXX: need to at least ensure singleton class for such a static reference to be safe
static CAddin *pAddin;

/////////////////////////////////////////////////////////////////////////////
// CAddin

STDMETHODIMP CAddin::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IAddin
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}


STDMETHODIMP CAddin::OnConnection(IDispatch * Application, ext_ConnectMode ConnectMode,
								  IDispatch * AddInInst, SAFEARRAY * * custom)
{
	USES_CONVERSION;
	pAddin = this;


//	MessageBox(NULL, _T("Hello"), _T(""), MB_OK);

	CComPtr <Office::_CommandBars> spCmdBars; 
	CComPtr <Office::CommandBar> spCmdBar;

	// QI() for _Application
	CComQIPtr<Outlook::_Application> spApp(Application); 
	ATLASSERT(spApp);
	m_spApp = spApp;
	// get the CommandBars interface that represents Outlook's
 	//toolbars & menu items	

	CComPtr<Outlook::_Explorer> spExplorer; 
	spApp->ActiveExplorer(&spExplorer);

	HRESULT hr =  spExplorer->get_CommandBars(&spCmdBars);
	if(FAILED(hr))
		return hr;
	ATLASSERT(spCmdBars);

	// now we add a new toolband to Outlook
	// to which we'll add 2 buttons
	CComVariant vName("SpamWatch");
	CComPtr<Office::CommandBar> spNewCmdBar;
	
	// position it below all toolbands
	//MsoBarPosition::msoBarTop = 1
	CComVariant vPos(1); 

	CComVariant vTemp(VARIANT_TRUE); // menu is temporary		
	CComVariant vEmpty(DISP_E_PARAMNOTFOUND, VT_ERROR);			
	//Add a new toolband through Add method
	// vMenuTemp holds an unspecified parameter
	//spNewCmdBar points to the newly created toolband
	spNewCmdBar = spCmdBars->Add(vName, vPos, vEmpty, vTemp);

	//now get the toolband's CommandBarControls
	CComPtr <Office::CommandBarControls> spBarControls;
	spBarControls = spNewCmdBar->GetControls();
	ATLASSERT(spBarControls);
	
	//MsoControlType::msoControlButton = 1
	CComVariant vToolBarType(1);
	//show the toolbar?
	CComVariant vShow(VARIANT_TRUE);
	
	CComPtr <Office::CommandBarControl> spNewBar; 
	CComPtr <Office::CommandBarControl> spNewBar2; 
	CComPtr <Office::CommandBarControl> spNewBar3; 
			
	// add first button
	spNewBar = spBarControls->Add(vToolBarType, vEmpty, vEmpty, vEmpty, vShow); 
	ATLASSERT(spNewBar);
	// add 2nd button
	spNewBar2 = spBarControls->Add(vToolBarType, vEmpty, vEmpty, vEmpty, vShow);
	ATLASSERT(spNewBar2);
	// add 3nd button
	spNewBar3 = spBarControls->Add(vToolBarType, vEmpty, vEmpty, vEmpty, vShow);
	ATLASSERT(spNewBar3);
			
	_bstr_t bstrNewCaption(OLESTR("Block"));
	_bstr_t bstrTipText(OLESTR("Block this email as spam"));

	// get CommandBarButton interface for each toolbar button
	// so we can specify button styles and stuff
	// each button displays a bitmap and caption next to it
	CComQIPtr <Office::_CommandBarButton> spCmdButton(spNewBar);
	CComQIPtr <Office::_CommandBarButton> spCmdButton2(spNewBar2);
	CComQIPtr <Office::_CommandBarButton> spCmdButton3(spNewBar3);
			
	ATLASSERT(spCmdButton);
	ATLASSERT(spCmdButton2);
			
	// to set a bitmap to a button, load a 32x32 bitmap
	// and copy it to clipboard. Call CommandBarButton's PasteFace()
	// to copy the bitmap to the button face. to use
	// Outlook's set of predefined bitmap, set button's FaceId to 	//the
	// button whose bitmap you want to use
	HBITMAP hBmp = (HBITMAP)::LoadImage(_Module.GetResourceInstance(),
		MAKEINTRESOURCE(IDB_BLOCK),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);

	// put bitmap into Clipboard
	::OpenClipboard(NULL);
	::EmptyClipboard();
	::SetClipboardData(CF_BITMAP, (HANDLE)hBmp);
	::CloseClipboard();
	::DeleteObject(hBmp);

	// set style before setting bitmap
	spCmdButton->PutStyle(Office::msoButtonIconAndCaption);
			
	hr = spCmdButton->PasteFace();
	if (FAILED(hr))
		return hr;

	hBmp = (HBITMAP)::LoadImage(_Module.GetResourceInstance(),
		MAKEINTRESOURCE(IDB_UNBLOCK),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
	// put bitmap into Clipboard
	::OpenClipboard(NULL);
	::EmptyClipboard();
	::SetClipboardData(CF_BITMAP, (HANDLE)hBmp);
	::CloseClipboard();
	::DeleteObject(hBmp);
	// set style before setting bitmap
	spCmdButton2->PutStyle(Office::msoButtonIconAndCaption);
	hr = spCmdButton2->PasteFace();
	if (FAILED(hr))
		return hr;

	hBmp = (HBITMAP)::LoadImage(_Module.GetResourceInstance(),
		MAKEINTRESOURCE(IDB_CHECK),IMAGE_BITMAP,0,0,LR_LOADMAP3DCOLORS);
	// put bitmap into Clipboard
	::OpenClipboard(NULL);
	::EmptyClipboard();
	::SetClipboardData(CF_BITMAP, (HANDLE)hBmp);
	::CloseClipboard();
	::DeleteObject(hBmp);
	// set style before setting bitmap
	spCmdButton3->PutStyle(Office::msoButtonIconAndCaption);
	hr = spCmdButton3->PasteFace();
	if (FAILED(hr))
		return hr;


	spCmdButton->PutVisible(VARIANT_TRUE); 
	spCmdButton->PutCaption(OLESTR("Block")); 
	spCmdButton->PutEnabled(VARIANT_TRUE);
	spCmdButton->PutTooltipText(OLESTR("Block as spam")); 
	spCmdButton->PutTag(OLESTR("Tag for Item1")); 
	
	//show the toolband
	spNewCmdBar->PutVisible(VARIANT_TRUE); 
			
//	spCmdButton2->PutStyle(Office::msoButtonIconAndCaption);
	
	//specify predefined bitmap
//	spCmdButton2->PutFaceId(1758);  
	
	spCmdButton2->PutVisible(VARIANT_TRUE); 
	spCmdButton2->PutCaption(OLESTR("Unblock")); 
	spCmdButton2->PutEnabled(VARIANT_TRUE);
	spCmdButton2->PutTooltipText(OLESTR("Unblock")); 
	spCmdButton2->PutTag(OLESTR("Tag for Item2"));
	spCmdButton2->PutVisible(VARIANT_TRUE);

	//specify predefined bitmap
//	spCmdButton3->PutStyle(Office::msoButtonIconAndCaption);
//	spCmdButton3->PutFaceId(1760);  
	
	spCmdButton3->PutVisible(VARIANT_TRUE); 
	spCmdButton3->PutCaption(OLESTR("Check")); 
	spCmdButton3->PutEnabled(VARIANT_TRUE);
	spCmdButton3->PutTooltipText(OLESTR("Check the selected emails")); 
	spCmdButton3->PutTag(OLESTR("Tag for Item3"));
	spCmdButton3->PutVisible(VARIANT_TRUE);

	m_spButton1 = spCmdButton;
	m_spButton2 = spCmdButton2;
	m_spButton3 = spCmdButton3;


	//
	// Read configuration from registry
	//

	HKEY hKey;
	DWORD dwBufLen = 64;

	// default values
	m_server_port = 3788;
	_tcscpy(m_server_addr, _T("169.229.119.81"));

	if (RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\UC-Berkeley\\SpamWatch"), 0, 
		KEY_READ, &hKey) == ERROR_SUCCESS) {
		RegQueryValueEx(hKey, _T("ServerAddress"), NULL, NULL,
			(LPBYTE)m_server_addr, &dwBufLen);
		dwBufLen = 4;
		RegQueryValueEx(hKey, _T("ServerPort"), NULL, NULL,
			(LPBYTE)&m_server_port, &dwBufLen);
	}

	RegCloseKey(hKey);

//	char buf[100];
//	sprintf(buf, "Address: %s, Port: %d", m_server_addr, m_server_port);
//	MessageBox(NULL, buf, "Info", MB_OK);

	//
	// Make sure a "Junk" folder exists in user's mail folder
	//

	CComPtr <Outlook::_NameSpace> spNamespace;
	hr = spApp->GetNamespace(CComBSTR(_T("MAPI")), &spNamespace);
	if (FAILED(hr)) {
		error(_T("Cannot get MAPI"));
		return S_OK;
	}
	CComPtr<IDispatch> _spPersonalFolder;
	CComPtr<Outlook::_Folders> spFolders;
	spNamespace->GetDefaultFolder(olFolderInbox, &m_spInbox);
	m_spInbox->get_Parent(&_spPersonalFolder);
	CComQIPtr<Outlook::MAPIFolder> spPersonalFolder(_spPersonalFolder);
	
	spPersonalFolder->get_Folders(&spFolders);

	spFolders->Item(CComVariant(_T("Junk")), &m_spJunkFolder);

	if (!m_spJunkFolder) {
		spFolders->Add(CComBSTR(_T("Junk")), CComVariant(_T("Junk")), &m_spJunkFolder);
		if (!m_spJunkFolder) {
			error (_T("Cannot create junk email folder!"));
		} else {
			CComBSTR name;
			m_spJunkFolder->get_Name(&name);
			error(OLE2T(name));
		}
	}

	// Register events for new email arrivals
	// Do not use application.NewMail because that event doesn't provide
	// detailed info about the arrived emails

	m_spInbox->get_Items(&m_spInboxItems);
	hr = NewItemEvents::DispEventAdvise((IDispatch*)m_spInboxItems);
	if (FAILED(hr)) {
		error(_T("Failed."));
	}

	//connect to event source in OnConnection
	// m_spButton member variable is a smart pointer to _CommandBarButton
	// that is used to cache the pointer to the first toolbar button.

	hr = CommandButton1Events::DispEventAdvise((IDispatch*)m_spButton1);
	if (FAILED(hr))
		error(_T("Failed again."));
	CommandButton2Events::DispEventAdvise((IDispatch*)m_spButton2);
	CommandButton3Events::DispEventAdvise((IDispatch*)m_spButton3);


	bConnected = true;

	return S_OK;
}

STDMETHODIMP CAddin::OnDisconnection(ext_DisconnectMode RemoveMode, SAFEARRAY * * custom) 
{
	if(bConnected)
	{
		HRESULT hr = CommandButton1Events::DispEventUnadvise((IDispatch*)m_spButton1);
		if(FAILED(hr))
			return hr;
		hr = CommandButton2Events::DispEventUnadvise((IDispatch*)m_spButton2);
		if(FAILED(hr))
			return hr;
		hr = CommandButton3Events::DispEventUnadvise((IDispatch*)m_spButton3);
		if(FAILED(hr))
			return hr;
		NewItemEvents::DispEventUnadvise((IDispatch*)m_spInboxItems);
		bConnected = false;
	}
	return S_OK;
}


_ATL_FUNC_INFO OnClickButton1Info ={CC_STDCALL,VT_EMPTY,2,{VT_DISPATCH,VT_BYREF | VT_BOOL}};
_ATL_FUNC_INFO OnClickButton2Info ={CC_STDCALL,VT_EMPTY,2,{VT_DISPATCH,VT_BYREF | VT_BOOL}};
_ATL_FUNC_INFO OnClickButton3Info ={CC_STDCALL,VT_EMPTY,2,{VT_DISPATCH,VT_BYREF | VT_BOOL}};
_ATL_FUNC_INFO OnNewItemInfo = {CC_STDCALL,VT_EMPTY,1,{VT_DISPATCH}};


void __stdcall TimerFunc(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime) 
{
	if (idEvent != pAddin->m_timer)
		return;					// This message is from the just deleted old timer, so ignore it
	KillTimer(NULL, idEvent);
	pAddin->m_client->Join(10000);
	pAddin->m_client->Close();
	delete pAddin->m_client;
	pAddin->m_client=NULL;
//	MessageBox(NULL, _T("Closing connection"), _T("Info"), MB_OK);
}


void __stdcall CAddin::OnNewItem(IDispatch * Item)
{
	USES_CONVERSION;
//	error(_T("New item."));
	if (!Item) {
		error(_T("Item is null!"));
		return;
	}
	CComQIPtr<Outlook::_MailItem> spMailItem(Item);
	if (!spMailItem) {
		error(_T("New item is not a mail item."));
		return;
	}

	CComPtr<Outlook::UserProperties> spUserProperties;
	spMailItem->get_UserProperties(&spUserProperties);
	CComPtr<Outlook::UserProperty> spProp;
	spUserProperties->Item(CComVariant(OLESTR("SpamWatch")), &spProp);
	if (spProp) {
		/*
		TCHAR buf[200];
		CComVariant v;
		spProp->get_Value(&v);
		_stprintf(buf, _T("Value: %s"), OLE2T(v.bstrVal));
		error(buf);
		*/
		// Already processed
//		MessageBox(NULL, _T("Already processed"), _T("Info"), MB_OK);
		return;
	}
	spUserProperties->Add(CComBSTR("SpamWatch"), Outlook::olText, CComVariant(false),
		CComVariant((long)0), &spProp);
	spProp->put_Value(CComVariant(1));

	// Use the client to check the MailItem
	if (!m_client) {
		m_client = new SpamWatchClient();
		m_client->Connect(m_server_addr, m_server_port, ResultHandler);
	}

	CComBSTR spBody;
	spMailItem->get_Body(&spBody);
		
	// Refcount is decremented in result_handler()
	m_client->CheckText(OLE2T(spBody), spMailItem.Detach());
	// TODO: removing this join will enable pipelining
	// But maybe we need another thread to receive the results, or we can buffer them until we
	// close the sockets
	m_client->Join(10000);

	// Set a timer to close the connection after 10 seconds of idling
	if (m_timer != 0)
		KillTimer(NULL, m_timer);
	m_timer = SetTimer(NULL, 0, 10000, TimerFunc);
}


// Block
void __stdcall CAddin::OnClickButton1(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault) 
{
	Vote(1);
}

// Unblock
void __stdcall CAddin::OnClickButton2(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault) 
{
	Vote(0);
}

// Vote for all selected emails
// 1 for block, 0 for unblock
void CAddin::Vote(int vote)
{
	USES_CONVERSION;
	SpamWatchClient client;
	client.Connect(m_server_addr, m_server_port, ResultHandler);

	CComPtr<Outlook::_Explorer> spExplorer;
	CComPtr<Outlook::Selection> spSelection;

	m_spApp->ActiveExplorer(&spExplorer);
	spExplorer->get_Selection(&spSelection);

	long count;
	spSelection->get_Count(&count);
	int votecount = 0;

	for (int i = 1; i <= count; i++) {
		CComPtr<IDispatch> spDispatch;

		spSelection->Item(CComVariant(i), &spDispatch);
		CComQIPtr<Outlook::_MailItem> spMailItem(spDispatch);

		if (spMailItem) {
			// Do the vote
			CComBSTR bzBody;
			spMailItem->get_Body(&bzBody);
			client.Vote(OLE2T(bzBody), vote);
			votecount ++;
		}
	}
	client.Join(10000);
	client.Close();

	// Move the emails
	for (i = 1; i <= count; i++) {
		CComPtr<IDispatch> spDispatch;
		spSelection->Item(CComVariant(i), &spDispatch);
		CComQIPtr<Outlook::_MailItem> spMailItem(spDispatch);
		CComPtr<IDispatch> spTargetItem;
		if (spMailItem) {
			// Move the email
			if (vote == 0)
				spMailItem->Move(m_spInbox, &spTargetItem);
			else
				spMailItem->Move(m_spJunkFolder, &spTargetItem);
		}
	}

//	TCHAR buf[50];
//	_stprintf(buf, _T("%d votes sented to server"), votecount);
//	MessageBox(NULL, buf, _T("Info"), MB_OK);
}

void CAddin::error(LPCTSTR message) {
	MessageBox(NULL, message, _T("Error!"), MB_OK);
}

// Check
void __stdcall CAddin::OnClickButton3(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault) 
{
	//_beginthread(ThreadFunc, 0, this);

	// Cannot do MailItem->get_Body in a thread?  (Access violation)
	// Temporarily back-off threading for now.
	ThreadFunc(this);
}

void __cdecl CAddin::ThreadFunc(void * arg) 
{
	USES_CONVERSION;

	CAddin *addin = (CAddin *)arg;
	CComPtr<Outlook::_Explorer> spExplorer;
	HRESULT hr = addin->m_spApp->ActiveExplorer(&spExplorer);
	if (FAILED(hr)) {
		addin->error (_T("Cannot get active explorer!"));
		return;
	}
	
	CComPtr<Outlook::Selection> spSelection;
	hr = spExplorer->get_Selection(&spSelection);

	long count;
	hr = spSelection->get_Count(&count);

	TCHAR buf[20];
	_stprintf(buf, _T("count: %ld"), count);
//	addin->error (buf);

	int i;

	SpamWatchClient client;
	client.Connect(addin->m_server_addr, addin->m_server_port, ResultHandler);
	
	for (i = 1; i <= count; i++) {
		IDispatchPtr ptr;
		CComVariant v(i);
		spSelection->Item(v, &ptr);
		
		CComQIPtr<Outlook::_MailItem> spMailItem(ptr);
		if (spMailItem==NULL) {
			addin->error (_T("Cannot get mail item"));
			return;
		}
			
		CComBSTR spBody;

		spMailItem->get_Body(&spBody);
		
		// Refcount is decremented in result_handler()
		client.CheckText(OLE2T(spBody), spMailItem.Detach());
	}

	client.Join(10000);		// time out is 10 secs
	client.Close();

}

void CAddin::ResultHandler(int seq, int result, void *arg) {
	USES_CONVERSION;

	_MailItem *mailItem = (_MailItem *)arg;

	CComPtr<IDispatch> spTarget;

	if (result == SPAM)
		mailItem->Move(pAddin->m_spJunkFolder, &spTarget);

	mailItem->Release();
}