// Addin.h : Declaration of the CAddin

#ifndef __ADDIN_H_
#define __ADDIN_H_

#include "resource.h"       // main symbols
#include "SpamWatchClient.h"
#import "C:\Program Files\Common Files\designer\MSADDNDR.TLB" raw_interfaces_only, raw_native_types, no_namespace, named_guids 

extern _ATL_FUNC_INFO OnClickButton1Info;
extern _ATL_FUNC_INFO OnClickButton2Info;
extern _ATL_FUNC_INFO OnClickButton3Info;
extern _ATL_FUNC_INFO OnNewItemInfo;

/////////////////////////////////////////////////////////////////////////////
// CAddin
class ATL_NO_VTABLE CAddin : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CAddin, &CLSID_Addin>,
	public ISupportErrorInfo,
	public IDispatchImpl<IAddin, &IID_IAddin, &LIBID_SPAMWATCHADDINLib>,
	public IDispatchImpl<_IDTExtensibility2, &IID__IDTExtensibility2, &LIBID_AddInDesignerObjects>,
	public IDispEventSimpleImpl<1,CAddin,&__uuidof(Office::_CommandBarButtonEvents)>,
	public IDispEventSimpleImpl<2,CAddin,&__uuidof(Office::_CommandBarButtonEvents)>,
	public IDispEventSimpleImpl<3,CAddin,&__uuidof(Office::_CommandBarButtonEvents)>,
	public IDispEventSimpleImpl<4,CAddin,&__uuidof(Outlook::ItemsEvents)>
{
public:
	typedef IDispEventSimpleImpl</*nID =*/ 1,CAddin, &__uuidof(Office::_CommandBarButtonEvents)> CommandButton1Events;
	typedef IDispEventSimpleImpl</*nID =*/ 2,CAddin, &__uuidof(Office::_CommandBarButtonEvents)> CommandButton2Events;
	typedef IDispEventSimpleImpl</*nID =*/ 3,CAddin, &__uuidof(Office::_CommandBarButtonEvents)> CommandButton3Events;
	typedef IDispEventSimpleImpl<4, CAddin, &__uuidof(Outlook::ItemsEvents)> NewItemEvents;

	CAddin()
	{
		m_client = NULL;
		m_timer = 0;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ADDIN)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CAddin)
	COM_INTERFACE_ENTRY(IAddin)
//DEL 	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY2(IDispatch, IAddin)
	COM_INTERFACE_ENTRY(_IDTExtensibility2)
END_COM_MAP()

BEGIN_SINK_MAP(CAddin)
	SINK_ENTRY_INFO(1, __uuidof(Office::_CommandBarButtonEvents),/*dispid*/
		0x01, OnClickButton1, &OnClickButton1Info)
	SINK_ENTRY_INFO(2, __uuidof(Office::_CommandBarButtonEvents),/*dispid*/
		0x01, OnClickButton2, &OnClickButton2Info)
	SINK_ENTRY_INFO(3, __uuidof(Office::_CommandBarButtonEvents),/*dispid*/
		0x01, OnClickButton3, &OnClickButton3Info)
	SINK_ENTRY_INFO(4, __uuidof(Outlook::ItemsEvents),
		0x0000f001, OnNewItem, &OnNewItemInfo)
END_SINK_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IAddin
public:
// _IDTExtensibility2
	STDMETHOD(OnConnection)(IDispatch * Application, ext_ConnectMode ConnectMode, IDispatch * AddInInst, SAFEARRAY * * custom);

	STDMETHOD(OnDisconnection)(ext_DisconnectMode RemoveMode, SAFEARRAY * * custom);

	STDMETHOD(OnAddInsUpdate)(SAFEARRAY * * custom)
	{
		return E_NOTIMPL;
	}
	STDMETHOD(OnStartupComplete)(SAFEARRAY * * custom)
	{
		return E_NOTIMPL;
	}
	STDMETHOD(OnBeginShutdown)(SAFEARRAY * * custom)
	{
		return E_NOTIMPL;
	}

	void __stdcall OnClickButton1(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault);
	void __stdcall OnClickButton2(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault);
	void __stdcall OnClickButton3(IDispatch * /*Office::_CommandBarButton**/ Ctrl,VARIANT_BOOL * CancelDefault);
	void __stdcall OnNewItem(IDispatch * Item);

	// XXX: has to be here for access from C function
	SpamWatchClient *m_client;
	UINT m_timer;			// Timer used to disconnect the client 
							// from server after a fixed idle time

private:

	void error(LPCTSTR message);
	void Vote(int vote);
	static void ThreadFunc(void * arg); 
	static void ResultHandler(int seq, int result, void *arg);

	CComPtr<Office::_CommandBarButton> m_spButton1; 
	CComPtr<Office::_CommandBarButton> m_spButton2; 
	CComPtr<Office::_CommandBarButton> m_spButton3; 
	bool bConnected;
	CComPtr<Outlook::_Application> m_spApp;
	CComPtr<Outlook::_Items> m_spInboxItems;
	CComPtr<Outlook::MAPIFolder> m_spJunkFolder, m_spInbox;

	TCHAR m_server_addr[64];
	int m_server_port;
};

#endif //__ADDIN_H_
