Name "SpamWatch Outlook Addin"
OutFile spamwatch-0.1.exe
BrandingText " "
InstallDir "$PROGRAMFILES\SpamWatch"
SilentInstall normal

;LicenseText "License Agreement"
;LicenseData licence.txt

Section "Check Outlook Installation"
  ; Test whether outlook 2000/XP is installed
  ClearErrors
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Office\9.0\Outlook\InstallRoot" Path
  IfErrors CheckOffice10
  goto Continue
  
  CheckOffice10:
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Office\10.0\Outlook\InstallRoot" Path
  IfErrors NoOffice
  goto Continue
  
  NoOffice:
  MessageBox MB_YESNO|MB_ICONSTOP|MB_SETFOREGROUND "SpamWatch Outlook Addin requires Outlook 2000/XP, which does not seem to be installed on your computer.  Do you still want to continue."  IDYES Continue
  Quit
  
  Continue:

SectionEnd


; The text to prompt the user to enter a directory
DirText "This will install SpamWatch Outlook Addin.  SpamWatch is a spam filtering service using peer-to-peer networking." "Select installation directory:"
;SubCaption 2 ": Installation Directory"
ShowInstDetails show

Section Install
  SetOutPath $INSTDIR
  File "..\ReleaseMinSize\SpamWatchAddin.dll"
  File readme.txt
  RegDLL "$INSTDIR\SpamWatchAddin.dll"
  WriteUninstaller $INSTDIR\Uninst.exe
SectionEnd

Section "Start Menu"
  SetOutPath "$SMPROGRAMS\SpamWatch 0.1"
  CreateShortCut "$SMPROGRAMS\SpamWatch 0.1\README.lnk" "$INSTDIR\readme.txt"
  CreateShortCut "$SMPROGRAMS\SpamWatch 0.1\Uninstall SpamWatch.lnk" "$INSTDIR\Uninst.exe"
  WriteINIStr "$SMPROGRAMS\SpamWatch 0.1\Visit SpamWatch Website.url" \
              "InternetShortcut" "URL" "http://www.cs.berkeley.edu/~zf/spamwatch/"
SectionEnd

Section "Uninstall"
  Delete $INSTDIR\Uninst.exe
  UnRegDLL $INSTDIR\SpamWatchAddin.dll
  Delete $INSTDIR\SpamWatchAddin.dll
  RMDir $INSTDIR
  RMDIR /r "$SMPROGRAMS\SpamWatch 0.1"
  DeleteRegKey HKCU SOFTWARE\Microsoft\Office\Outlook\Addins\SpamWatchAddin.Addin
  DeleteRegKey HKCU SOFTWARE\UC-Berkeley\SpamWatch
SectionEnd

;eof